package com.qmth.eds.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qmth.eds.common.entity.ExamSyncStudent;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

/**
 * 考务数据同步考生信息表 Mapper 接口
 */
public interface ExamSyncStudentMapper extends BaseMapper<ExamSyncStudent> {

    /**
     * 根据机构id、考试id、科目代码查询考查学院
     *
     * @param schoolId
     * @param orgId
     * @param examId
     * @param courseCode
     * @param subjectCodeSet
     * @return
     */
    List<ExamSyncStudent> queryByExamineCollegeList(@Param("schoolId") Long schoolId, @Param("orgId") Long orgId, @Param("examId") Long examId, @Param("courseCode") String courseCode, @Param("subjectCodeSet") Set<String> subjectCodeSet);
}
