package com.qmth.eds.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.eds.bean.dto.CloudMarkingScoreDto;
import com.qmth.eds.bean.dto.ExamSyncStudentDto;
import com.qmth.eds.common.entity.CloudMarkingScore;

import java.util.List;

/**
 * 云阅卷成绩表 服务类
 */
public interface CloudMarkingScoreService extends IService<CloudMarkingScore> {

    void deleteByKeys(Long schoolId, Long semesterId, Long examTypeId, Integer examId);

    IPage<CloudMarkingScoreDto> pageData(Long collegeId, Long semesterId, Long examTypeId, String examId, Integer pageNumber, Integer pageSize);

    /**
     * 根据科目代码查询
     *
     * @param schoolId
     * @param orgId
     * @param courseCode
     * @return
     */
    List<CloudMarkingScore> queryBySyncCourseCode(Long schoolId, Long orgId, String courseCode);

    List<ExamSyncStudentDto> listExamSyncStudentDtos(Long schoolId, Long semesterId, Long examTypeId, String courseCode, String openCollege);
}
