package com.qmth.eds.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.eds.common.entity.BasicSchool;
import com.qmth.eds.common.entity.SysUser;
import com.qmth.eds.mapper.BasicSchoolMapper;
import com.qmth.eds.service.BasicSchoolService;
import com.qmth.eds.service.SysUserService;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 学校表 服务实现类
 * </p>
 *
 * @author wangliang
 * @since 2022-05-14
 */
@Service
public class BasicSchoolServiceImpl extends ServiceImpl<BasicSchoolMapper, BasicSchool> implements BasicSchoolService {

    @Resource
    SysUserService sysUserService;

    @Override
    public List<BasicSchool> listByUser(String loginName) {
        QueryWrapper<SysUser> sysUserQueryWrapper = new QueryWrapper<>();
        sysUserQueryWrapper.lambda().eq(SysUser::getLoginName, loginName)
                .isNotNull(SysUser::getSchoolId);
        List<SysUser> sysUsers = sysUserService.list(sysUserQueryWrapper);
        if (!CollectionUtils.isEmpty(sysUsers)) {
            List<Long> schoolIds = sysUsers.stream().map(SysUser::getSchoolId).collect(Collectors.toList());
            QueryWrapper<BasicSchool> basicSchoolQueryWrapper = new QueryWrapper<>();
            basicSchoolQueryWrapper.lambda().in(BasicSchool::getId, schoolIds)
                    .orderByAsc(BasicSchool::getId);
            return this.list(basicSchoolQueryWrapper);
        }
        return null;
    }
}
