package com.qmth.eds.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.eds.bean.dto.CloudMarkingScoreDto;
import com.qmth.eds.bean.dto.ExamSyncStudentDto;
import com.qmth.eds.common.entity.CloudMarkingScore;
import com.qmth.eds.common.util.ServletUtil;
import com.qmth.eds.mapper.CloudMarkingScoreMapper;
import com.qmth.eds.service.CloudMarkingScoreService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class CloudMarkingScoreServiceImpl extends ServiceImpl<CloudMarkingScoreMapper, CloudMarkingScore> implements CloudMarkingScoreService {

    @Resource
    CloudMarkingScoreMapper cloudMarkingScoreMapper;

    @Override
    public void deleteByKeys(Long schoolId, Long semesterId, Long examTypeId, Integer examId) {
        UpdateWrapper<CloudMarkingScore> updateWrapper = new UpdateWrapper<>();
        updateWrapper.lambda().eq(CloudMarkingScore::getSchoolId, schoolId)
                .eq(CloudMarkingScore::getSemesterId, semesterId)
                .eq(CloudMarkingScore::getExamTypeId, examTypeId)
                .eq(CloudMarkingScore::getExamId, examId);
        this.remove(updateWrapper);
    }

    @Override
    public IPage<CloudMarkingScoreDto> pageData(Long collegeId, Long semesterId, Long examTypeId, String examId, Integer pageNumber, Integer pageSize) {
        Long schoolId = Long.valueOf(ServletUtil.getRequestHeaderSchoolId().toString());
        Page<CloudMarkingScoreDto> page = new Page<>(pageNumber, pageSize);
        return this.baseMapper.pageData(page, collegeId, semesterId, examTypeId, examId);
    }

    /**
     * 根据科目代码查询
     *
     * @param schoolId
     * @param orgId
     * @param courseCode
     * @return
     */
    @Override
    public List<CloudMarkingScore> queryBySyncCourseCode(Long schoolId, Long orgId, String courseCode) {
        return cloudMarkingScoreMapper.queryBySyncCourseCode(schoolId, orgId, courseCode);
    }

    @Override
    public List<ExamSyncStudentDto> listExamSyncStudentDtos(Long schoolId, Long semesterId, Long examTypeId, String courseCode, String openCollege) {
        return this.baseMapper.listExamSyncStudentDtos(schoolId, semesterId, examTypeId, courseCode, openCollege);
    }
}
